# Contributing to Chproxy

Thank you for considering to contribute to CHProxy. We value your help on the project, whether it is by:

- Reporting a bug
- Improving documentation
- Submitting a fix
- Proposing new features

## Contributing Code

We use [Github Flow](https://docs.github.com/en/get-started/quickstart/github-flow), so all code changes are made via pull requests.

Before making a pull request, make sure to communicate what you aim to achieve with your PR to smoothen the process. Consider [opening an issue](https://github.com/ContentSquare/chproxy/issues) before creating your PR.

To create a PR:

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs or added a new feature, update the documentation.
4. Ensure the test suite passes.
5. Make sure your code lints.

For first time contributors running the CI pipelines require explicit maintainer approval. Ping one of the maintainers on your PR to ask for a CI run. Thank you for your understanding.

Note that we do not accept "cosmetic PRs" that functionally do not change anything as they have little value for the project. 
## Reporting bugs

We use GitHub issues to track public bugs. Report a bug by [opening an issue](https://github.com/ContentSquare/chproxy/issues). You can use the Bug Report template to report an issue with Chproxy.

**Great Bug Reports** tend to have:

- A quick summary and/or background
- Steps to reproduce
- What you expected would happen
- What actually happened
- Notes:
  - Do you have any metrics available that might be relevant?
  - Do you suspect a root cause?
  - Anything else that can contribute to the report.

## Improving the documentation

We greatly value improvements to the documentation! If you feel like certain areas of Chproxy are not well documented, but are unsure how to document them, you can also help by [opening an issue](https://github.com/ContentSquare/chproxy/issues).

## License

By contributing, you agree that your contributions will be licensed under its MIT License.
